#include "StdAfx.h"
#include "SimpleListBoxItemPanel.h"
#include "ScriptletAction.h"
#include "SimpleTextShape.h"

namespace tipuio {

REGISTER_COMPONENT_CREATOR(_T("SimpleListBoxItemPanel"), SimpleListBoxItemPanel);
SimpleListBoxItemPanel::SimpleListBoxItemPanel(void)
{
}

SimpleListBoxItemPanel::~SimpleListBoxItemPanel(void)
{
}
void SimpleListBoxItemPanel::OnCreate()
{
	__super::OnCreate();
	this->AddMouseListener(dynamic_cast<IMouseListener*>(this));
}
void SimpleListBoxItemPanel::OnDestroy()
{
	this->RemoveMouseListener(dynamic_cast<IMouseListener*>(this));
	__super::OnDestroy();
}
void SimpleListBoxItemPanel::OnSetItem(Item* pItem)
{
	__super::OnSetItem(pItem);

	CComponent* pComponent = this->FindName(_T("simplelisitem_text"));
	CSimpleTextShape* pTextShape = dynamic_cast<CSimpleTextShape*>(pComponent);
	if (pTextShape)
	{
		pTextShape->SetText(this->GetItem()->ToString());
	}
}
void SimpleListBoxItemPanel::OnSelected()
{
	CComponent* pComponent = this->FindName(_T("simplelistitem_background"));
	if (pComponent)
	{
		pComponent->SetVisible(TRUE);
	}
	CSimpleTextShape* textshape = dynamic_cast<CSimpleTextShape*>(this->FindName(_T("simplelisitem_text")));
	if (textshape != NULL)
	{
		textshape->SetBold(TRUE);
	}
}
void SimpleListBoxItemPanel::OnUnselected()
{
	CComponent* pComponent = this->FindName(_T("simplelistitem_background"));
	if (pComponent)
	{
		pComponent->SetVisible(FALSE);
	}
	CSimpleTextShape* textshape = dynamic_cast<CSimpleTextShape*>(this->FindName(_T("simplelisitem_text")));
	if (textshape != NULL)
	{
		textshape->SetBold(FALSE);
	}
}
void SimpleListBoxItemPanel::OnMouseEntered(CMouseEvent* pMouseEvent)
{
	CComponent* pComponent = this->FindName(_T("simplelistitem_over"));
	if (pComponent)
	{
		pComponent->SetVisible(TRUE);
		pComponent->Invalidate();
	}
}
void SimpleListBoxItemPanel::OnMouseExited(CMouseEvent* pMouseEvent)
{
	CComponent* pComponent = this->FindName(_T("simplelistitem_over"));
	if (pComponent)
	{
		pComponent->SetVisible(FALSE);
		this->Invalidate();
	}
}

};